function redirectToWaypointTag(tag)
	local idx = __WPL:findWaypointTag(tag);
	__WPL:setWaypointIndex(idx);
end;

function Mobs_Add(target)
	if (AddTextToIList(settings.profile.mobs, target)) then
		printf("Added "..tostring(target).." to mob list\n");
	end;
end;

function Mobs_Remove(target)
	if (RemoveTextFromIList(settings.profile.mobs, target)) then
		printf("Removed "..tostring(target).." from mob list\n");
	end;
end;

function Friends_Add(target)
	if (AddTextToIList(settings.profile.friends, target)) then
		printf("Added '"..tostring(target).."' to friends list\n");
	end;
end;

function Friends_Remove(target)
	if (RemoveTextFromIList(settings.profile.friends, target)) then
		printf("Removed "..tostring(target).." from friends list\n");
	end;
end;

function AddTextToIList(plist, text)
	local foundIndex = GetIndexOfListItem(plist,text);
	
	if (foundIndex > -1) then 
		--printf(text.." was already in list\n");
		return false; 
	end;
	table.insert(plist, text);
	return true;
end;

function RemoveTextFromIList(plist, text)
	local foundIndex = GetIndexOfListItem(plist,text);
	
	if (foundIndex == -1) then 
		--printf(text.." was not in list\n");
		return false; 
	end;
	table.remove(plist, foundIndex);
	return true;
end;

function GetIndexOfListItem(plist, item)
	local foundIndex = -1;
	for i,v in ipairs(plist) do
		if (v == item) then
			foundIndex = i;
			break;
		end;
	end;
	
	return foundIndex;
end;
