setExecutionPath(getExecutionPath().."/..")
include "geom.lua";

function __log(filename, text)
	if ((filename ~= nil) and (text ~= nil)) then
		filename = getExecutionPath() .. "/logs/"..filename;
		file, err = io.open(filename, "a+");
		if( not file ) then
			error(err, 0);
		end

		file:write(text.."\n")
		file:close();
	end
end

function __logWithTime(filename, text)
	text = tostring(os.date("%c"))..": "..text
	__log(filename, text)
end

function KSLog(_comment)
	__logWithTime("KS.log", _comment);
end

function CheckForFullInventory()
	CleanBag(300,3);
	if (inventory:itemTotalCount(0) < 1)  then    
		sendMacro("LeaveParty();");
		yrest(4000)
		waitForLoadingScreen(); 
		player:update();
		__WPL:setWaypointIndex(__WPL:findWaypointTag("rerun"));
	end 
end
	
function PointInRect(_rect, _x, _z)
	
	local pt = Point(_x,0,_z);
	local origin = Point(_rect.cx, 0, _rect.cz);
	local v1 = Point(_rect.v1x, 0, _rect.v1z);
	local v2 = Point(_rect.v2x, 0, _rect.v2z);
	
	printf("evaluting target in rect: "..tostring(origin).." : "..tostring(v1).." : "..tostring(v2).."\n");
	printf("point: "..tostring(pt).."\n");
	
	v1 = v1-origin;
	v2 = v2-origin;
	local v = pt-origin;
	
	local dp_v_v1 =  v..v1;
	local dp_v1_v1 = v1..v1;
	local dp_v_v2 = v..v2;
	local dp_v2_v2 = v2..v2;
	
	local result = (dp_v_v1 > 0);
	if (result == false) then return false; end;
	result = (dp_v_v1 < dp_v1_v1);
	if (result == false) then return false; end;
	
	result = (dp_v_v2 > 0);
	if (result == false) then return false; end;
	result = (dp_v_v2 < dp_v2_v2);

	
	return result;
end

KS_target_rect = nil;

function KSevalTargetFunc(address, target)
	local canTarget = KS_old_evalTargetDefault(address, target);
	if ((canTarget) and (KS_target_rect)) then
		--check that target is in current box
		return PointInKillRect(target.X, target.Z);
	end;
	
	return canTarget;
end;

function KSSetKillZone(_rect)
	KS_target_rect = _rect;
	if (_rect ~= nil) then
		KSorigin = Point(_rect.cx, 0, _rect.cz);
		KSv1 = Point(_rect.v1x, 0, _rect.v1z);
		KSv2 = Point(_rect.v2x, 0, _rect.v2z);
		KSv1 = KSv1-KSorigin;
		KSv2 = KSv2-KSorigin;
		KSdp_v1_v1 = KSv1..KSv1;
		KSdp_v2_v2 = KSv2..KSv2;
	else
	end;
end;

function PointInKillRect(_x, _z)
	local pt = Point(_x,0,_z);
	local v = pt-KSorigin;
	
--	printf("evaluting target in rect: "..tostring(KSorigin).." : "..tostring(KSv1).." : "..tostring(KSv2).."\n");
--	printf("point: "..tostring(pt).."\n");
	

	
	local dp_v_v1 =  v..KSv1;
	local dp_v_v2 = v..KSv2;
	
	local result = (dp_v_v1 > 0);
	if (result == true) then result = (dp_v_v1 < KSdp_v1_v1); end;
	if (result == true) then result = (dp_v_v2 > 0); end;
	if (result == true) then result = (dp_v_v2 < KSdp_v2_v2); end;

	return result;
end